/*
 * @Copyright 2010, MechSoft 
 * MechSoft, Mechanical and Software Solutions 
 * 
 * Licensed under the Apache License, Version 2.0 (the 
 * "License"); you may not use this file except in compliance 
 * with the License. You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
package org.defne.hotel.jsf;

import java.util.ArrayList;
import java.util.List;

import org.defne.jsf.JSFEjbServiceExecutorProxy;
import org.defne.samples.hotel.models.Hotel;
import org.defne.service.Message;
import org.defne.service.MessageFactory;

public class HotelBean
{

    private JSFEjbServiceExecutorProxy serviceExecutorBean;

    private String hotelName;

    private List<Hotel> hotels = new ArrayList<Hotel>();

    public HotelBean()
    {

    }

    public String addHotel()
    {
        Message bag = MessageFactory.newMessage("HotelService", "addHotel");
        bag.putMessageParameter("HOTEL_NAME", this.hotelName);

        bag = this.serviceExecutorBean.execute(bag);

        return null;
    }

    @SuppressWarnings("unchecked")
    public String listHotels()
    {
        Message bag = MessageFactory.newMessage("HotelService", "getHotels");
        bag = this.serviceExecutorBean.execute(bag);

        this.hotels = bag.getMessageParameter(List.class, "HOTEL_LIST");

        return "toListingPage";
    }

    /**
     * @return the serviceExecutorBean
     */
    public JSFEjbServiceExecutorProxy getServiceExecutorBean()
    {
        return serviceExecutorBean;
    }

    /**
     * @param serviceExecutorBean the serviceExecutorBean to set
     */
    public void setServiceExecutorBean(JSFEjbServiceExecutorProxy serviceExecutorBean)
    {
        this.serviceExecutorBean = serviceExecutorBean;
    }

    /**
     * @return the hotelName
     */
    public String getHotelName()
    {
        return hotelName;
    }

    /**
     * @param hotelName the hotelName to set
     */
    public void setHotelName(String hotelName)
    {
        this.hotelName = hotelName;
    }

    /**
     * @return the hotels
     */
    public List<Hotel> getHotels()
    {
        return hotels;
    }

    /**
     * @param hotels the hotels to set
     */
    public void setHotels(List<Hotel> hotels)
    {
        this.hotels = hotels;
    }

}
